• HDU-3486-Interviewe(二分+RMQ)


    Time Limit: 2000/1000 MS (Java/Others)    Memory Limit: 65536/32768 K (Java/Others)

    题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=3486

    Problem Description

    YaoYao has a company and he wants to employ m people recently. Since his company is so famous, there are n people coming for the interview. However, YaoYao is so busy that he has no time to interview them by himself. So he decides to select exact m interviewers for this task.
    YaoYao decides to make the interview as follows. First he queues the interviewees according to their coming order. Then he cuts the queue into m segments. The length of each segment is , which means he ignores the rest interviewees (poor guys because they comes late). Then, each segment is assigned to an interviewer and the interviewer chooses the best one from them as the employee.
    YaoYao’s idea seems to be wonderful, but he meets another problem. He values the ability of the ith arrived interviewee as a number from 0 to 1000. Of course, the better one is, the higher ability value one has. He wants his employees good enough, so the sum of the ability values of his employees must exceed his target k (exceed means strictly large than). On the other hand, he wants to employ as less people as possible because of the high salary nowadays. Could you help him to find the smallest m?
     

    Input

    The input consists of multiple cases.
    In the first line of each case, there are two numbers n and k, indicating the number of the original people and the sum of the ability values of employees YaoYao wants to hire (n≤200000, k≤1000000000). In the second line, there are n numbers v1, v2, …, vn (each number is between 0 and 1000), indicating the ability value of each arrived interviewee respectively.
    The input ends up with two negative numbers, which should not be processed as a case.
     

    Output

    For each test case, print only one number indicating the smallest m you can find. If you can’t find any, output -1 instead.
     

    Sample Input

    11 300
    7 100 7 101 100 100 9 100 100 110 110
    -1 -1
     

    Sample Output

    3

    Hint

    We need 3 interviewers to help YaoYao. The first one interviews people from 1 to 3, the second interviews people from 4 to 6, and the third interviews people from 7 to 9. And the people left will be ignored. And the total value you can get is 100+101+100=301>300.
     

    题目大意:给你n个人和tot,让你安排m个考官,每个考官负责[n/m]个人,其他的人忽略。让每个考官挑选他们组中能力值最好的,要求所有考官挑选出来的能力值总和要大于等于tot。问最少要安排多少个考官。
    很简单的一道题,二分考官人数,然后对每个考官所负责的区间进行RMQ找出最大值然后相加,看看是否>=tot。此题结束。。。
    以下是AC代码:
    #include <cstdio>
    #include <cstring>
    #include <queue>
    #include <algorithm>
    using namespace std;
    
    const int mac=2e5+10;
    
    int a[mac],mi[mac][30],mx[mac][30];
    
    void get_rmq(int n)
    {
        for (int i=1; i<=n; i++) mx[i][0]=a[i];
        for (int j=1; (1<<j)<=n; j++)
            for (int i=1; i+(1<<j)-1<=n; i++)
                mx[i][j]=max(mx[i][j-1],mx[i+(1<<(j-1))][j-1]);
    }
    
    int rmq(int l,int r)
    {
        int k=0; 
        while (1<<(k+1)<=(r-l+1)) k++;
        return max(mx[l][k],mx[r-(1<<k)+1][k]);
    }
    
    int ok(int x,int n,int tot)
    {
        int len=n/x;
        int sum=0;
        for (int l=1; l<=len*x;){
            sum+=rmq(l,l+len-1);
            l+=len;
        }
        if (sum>tot) return 1;
        return 0;
    }
    
    int main()
    {
        int n,m;
        while (scanf ("%d%d",&n,&m)){
            if (n<0 && m<0) return 0;
            int tot=0;
            for (int i=1; i<=n; i++){
                scanf("%d",&a[i]);
                tot+=a[i];
            }
            if (tot<=m) {printf("-1
    ");continue;}
            get_rmq(n);
            int l=1,r=n,mid,ans=0;
            while (l<=r){
                mid=(l+r)>>1;
                if (ok(mid,n,m)){
                    ans=mid;r=mid-1;
                }
                else l=mid+1;
            }
            printf("%d
    ",ans);
        }
        return 0;
    }
    路漫漫兮
  • 相关阅读:
    asp.net(c#)网页跳转七种方法小结
    asp.net用Zxing库实现条形码输出的具体实现
    SQL中 patindex函数的用法
    escape()、encodeURI()、encodeURIComponent()区别详解
    sql语句分页代码
    memcache安装
    LVS和Haproxy机器必须注意的几个参数
    Redis 三主三从集群搭建
    mogodb安装步骤及注意事项
    系统故障等级和故障报告规定
  • 原文地址:https://www.cnblogs.com/lonely-wind-/p/12196313.html
Copyright © 2020-2023  润新知